#! /usr/bin/env python
from PIL import Image
from PIL import ImageFont
from PIL import ImageDraw 
from data import *
import math
from copy import copy


#print(data[0])

def squeeze(data, check=0):
  data = copy(data)
  if check == min(map(len, data)) - 1:
    return data
  ret = []
  good = True
  for d in data:
    if check < len(d) and d[check] == " ":
      ret.append("")
      ret[-1] += d[:check]
      ret[-1] += d[min(check + 1, len(d) - 1):]
    else:
      return squeeze(data, check + 1)
  assert(len(ret) == len(data))
  assert(len(ret[5]) == len(data[5]) - 1)
  return squeeze(ret, check)
  
def line(img, x, y, hor, width):
  pixdata = img.load()
  for w in range(width):
    if hor:
      for i in xrange(img.size[0]):
        pixdata[x + i, y + w] = (0, 0, 0)
    else:
      for i in xrange(img.size[1]):
        pixdata[x + w, y + i] = (0, 0, 0)


def flip(data):
  newdata = []
  for ridx, row in enumerate(data):
    idx = [n for n in xrange(len(row)) if row.find('|', n) == n]
    if len(idx) == 4:
      if data[5][idx[2]:idx[3]].find("*") != -1:
        newdata.append(row[:idx[1]] + row[idx[2]:idx[3]] + row[idx[1]:idx[2]] + row[idx[3]:])
      else:
        newdata.append(row)
    else:
      newdata.append(row)
  assert(len(newdata) == len(data))
  return copy(newdata)


def gen(data, name):
  print(name)
  data = data.upper()
  data = data.replace("0", "R")
  data = data.replace("1", "0")
  data = data.replace("-", "W")
  data = data.replace("+", "A")
  data = data.replace("_", "#")
  data = data.replace("=", "T")
  data = data.replace(".", "L")
  data = data.replace(")", "P")
  data = data.replace("?", "Y")
  data = squeeze(data.split("\n"))
  if data[5][0] != "|":
    newdata = []
    for d in data:
      newdata.append("|" + d)
    data = copy(newdata)

  if data[5][len(data[5]) - 1] != "|":
    newdata = []
    for d in data:
      newdata.append(d + "|")
    data = copy(newdata)
  data = flip(data)
  div = [n for n in xrange(len(data[5])) if data[5].find('|', n) == n]
  many = 14
  img = Image.new('RGB', (3000, 3000))
  draw = ImageDraw.Draw(img)
  font = ImageFont.truetype("font.ttf", 34)
  fontB = ImageFont.truetype("fontB.ttf", 44)
  inters = []
  inters.append("Input Tape")
  if len(div) == 4:
    inters.append("Memory")
  inters.append("Output Tape")

  new = []

  for i, inp in enumerate(inters):
    new.append(inp + " " * (max(many, div[i + 1] - div[i] - 1) - len(inp)))
  inters = "|" + "|".join(new) + "|"
  data = [inters] + data

  width = 5
  pixdata = img.load()
  for y in xrange(img.size[1]):
    for x in xrange(img.size[0]):
      pixdata[x, y] = (255, 255, 255)

  line(img, 0, 0, True, width)
  line(img, 0, 0, False, width)
  x = 0
  mul = 1.2
  high = math.floor(mul * font.getsize("A")[1])
  y = -high + 15

  for ridx, row in enumerate(data):
    y += high
    if ridx == 1:
      y += 25
      line(img, 0, y, True, width)
      y += 15
    x = 15
    idx = [n for n in xrange(len(row)) if row.find('|', n) == n]
    for i in range(len(idx) - 1):
      r = row[(idx[i] + 1):idx[i + 1]] 
      r += " " * (many - len(r))
      if ridx == 0:
        draw.text((x, y), r, (31, 117, 254), font=fontB)
      else:
        if i == len(idx) - 2 and r.strip() != "#" and ridx > 2:
          ii = idx[len(idx) - 2] + r.find(r.strip()) + 1
          if ii < len(data[1]) and r.strip() != data[1][ii]:
            draw.text((x, y), r, (255, 0, 0), font=font)
          else:
            draw.text((x, y), r, (0, 153, 35), font=font)
        else:
          draw.text((x, y), r, (0, 0, 0), font=font)
      x += font.getsize(r)[0]
      x += 25
      if ridx > 1:
        line(img, x, 0, False, width)
      x += 25
  y += high 
  y += 15
  x -= 25 - width

  line(img, 0, int(y) - width, True, width)
  img = img.crop((0, 0, int(x), int(y)))
  img.save('traces/%s.png' % name)

names = ["forward_reverse", "reverse", "forward_reverse_big", "repeat_copy", "repeat_input", "forward_repeat_copy"]
for name, d in zip(names, data):
  gen(d, name)
